//in uso

#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>
#include <PubSubClient.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"

/*Temperature Sensor Settings*/
#include <WEMOS_DHT12.h>
DHT12 dht12;

#include "RemoteDebug.h"                  //https://github.com/JoaoLopesF/RemoteDebug
RemoteDebug Debug;

//IR LIB & settings
#include <IRsend.h>
#include <IRremoteESP8266.h>
#define IR_LED 12    //D6
IRsend irsend (IR_LED);

// Time
uint32_t mLastTime =            0;
uint32_t mTimeSeconds =         0;
unsigned long previousMillis =  0;        // will store last temp was read
const long interval =           4000;

/*WiFi Settings*/
const char* ssid =                        "NomeDellaTuaRete";
const char* password =                    "PasswordDellaTuaRete";
#define HOST_NAME                         "IrBlaster"
WiFiClient IrBlaster;
PubSubClient client(IrBlaster);

/*MQTT Settings*/
const char* mqtt_server =                 "192.168.1.118";    //  IP del tuo Raspberry Pi
const char* inTopic_irRemote =            "irRemote";
const char* inTopic_targetHumidity =      "HOME/Termostato/Target/Humidity";
const char* inTopic_targetTemperature =   "HOME/Termostato/Target/Temperature";
const char* inTopic_GEThumidity =         "HOME/Termostato/getStatus/Humidity";
const char* inTopic_GETtemperature =      "HOME/Termostato/getStatus/Temperature";
const char* inTopic_RecTemperature =      "HOME/Termostato/RecoveryTemperature";
const char* inTopic_RecHumidity =         "HOME/Termostato/RecoveryHumidity";
const char* outTopic_targetHCS =          "HOME/Termostato/Target/Hcs";
const char* outTopic_CurrentTemperature = "HOME/Termostato/Current/Temperature";
const char* outTopic_CurrentHumidity =    "HOME/Termostato/Current/Humidity";
const char* questMsg = "???";

float currHumidity, currTemperature, temp, humi;

int currHCS = 0;                                                    //Current Heating Cooling State
int targetHCS = 0;                                                  //Target Heating Cooling State
int tarHum = 35;                                                    //Target Humidity
int tarTem = 25;                                                    //Target Temperature

int prevTtemp;
int prevChcs;
int prevThum;

char msg[50];
int irstate = false;
int khz = 38;
//********************************************************************************************** IR SIGNALS
uint16_t Signal_OFF_0[] = {4472, 4452, 560, 1636, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 540, 556, 540, 556, 540, 556, 540, 556, 1636, 560, 536, 560, 536, 556, 1636, 560, 1632, 560, 1632, 556, 540, 560, 536, 560, 536, 560, 540, 556, 540, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 1636, 552, 1640, 556, 1636, 556, 5288, 4472, 4452, 556, 1640, 552, 540, 560, 1632, 556, 1640, 556, 540, 556, 540, 552, 1640, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 540, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 560, 1632, 556, 1636, 556, 540, 556, 540, 556, 540, 560, 536, 560, 540, 556, 540, 556, 536, 560, 536, 560, 1632, 560, 1632, 560, 1632, 560, 1636, 556, 1632, 560}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima30[] = {4492, 4428, 580, 1612, 580, 516, 584, 1608, 580, 1612, 580, 516, 580, 520, 576, 1612, 580, 516, 580, 520, 576, 1616, 576, 520, 576, 520, 580, 1612, 576, 1616, 580, 516, 580, 1612, 580, 1612, 580, 516, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 516, 580, 516, 580, 520, 576, 1616, 576, 516, 580, 1616, 576, 1616, 576, 520, 580, 516, 576, 520, 576, 520, 576, 520, 580, 1612, 576, 520, 576, 520, 580, 1612, 580, 1612, 576, 1616, 580, 1612, 580, 5268, 4492, 4432, 580, 1612, 580, 516, 580, 1612, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 1616, 576, 516, 580, 516, 580, 1616, 576, 1612, 580, 520, 576, 1616, 576, 1616, 576, 520, 580, 1612, 576, 1616, 576, 1616, 580, 1612, 580, 1612, 580, 1612, 580, 516, 580, 1612, 576, 520, 576, 520, 580, 516, 580, 516, 580, 516, 580, 516, 580, 1612, 580, 516, 556, 1636, 580, 1612, 580, 516, 580, 516, 580, 520, 576, 520, 572, 524, 576, 1616, 576, 520, 576, 520, 576, 1616, 576, 1616, 576, 1616, 576, 1616, 580}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima29[] = {4472, 4428, 560, 1636, 576, 520, 576, 1616, 556, 1636, 576, 520, 556, 540, 556, 1636, 572, 524, 580, 516, 556, 1636, 556, 540, 556, 540, 580, 1612, 556, 1636, 556, 544, 576, 1612, 580, 1612, 572, 524, 556, 1636, 556, 1640, 552, 1636, 580, 1616, 556, 1636, 576, 1616, 552, 544, 552, 1640, 576, 520, 556, 540, 568, 528, 576, 520, 572, 524, 580, 516, 576, 1616, 552, 544, 556, 1636, 580, 516, 556, 540, 580, 516, 556, 540, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 1612, 580, 1612, 556, 1636, 580, 1612, 580, 1616, 576, 5264, 4500, 4428, 556, 1636, 580, 516, 556, 1636, 580, 1612, 580, 516, 580, 520, 576, 1616, 576, 520, 580, 516, 576, 1616, 576, 520, 576, 520, 580, 1612, 552, 1640, 576, 520, 580, 1612, 580, 1612, 580, 516, 580, 1612, 580, 1612, 556, 1636, 580, 1612, 580, 1612, 580, 1612, 556, 540, 556, 1636, 580, 516, 556, 544, 576, 516, 580, 516, 556, 544, 576, 520, 580, 1612, 576, 520, 552, 1640, 552, 544, 552, 544, 576, 520, 576, 520, 576, 520, 552, 544, 576, 1616, 576, 520, 576, 1616, 556, 1636, 576, 1616, 580, 1612, 556, 1636, 556}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima28[] = {4472, 4432, 552, 1640, 552, 544, 552, 1640, 576, 1616, 552, 544, 556, 540, 576, 1616, 556, 540, 556, 540, 556, 1636, 576, 520, 552, 544, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 544, 576, 1612, 556, 1636, 556, 1636, 556, 1640, 552, 1640, 576, 1616, 556, 540, 552, 1640, 552, 544, 576, 520, 552, 544, 556, 540, 552, 544, 556, 540, 580, 1612, 556, 540, 552, 544, 556, 540, 576, 520, 580, 516, 576, 520, 556, 540, 556, 540, 580, 1612, 580, 1612, 556, 1636, 556, 1636, 556, 1636, 580, 1612, 556, 1640, 576, 5268, 4496, 4428, 556, 1636, 556, 544, 552, 1636, 556, 1636, 556, 540, 580, 520, 576, 1616, 552, 544, 556, 540, 576, 1616, 576, 520, 552, 544, 556, 1636, 556, 1636, 552, 544, 580, 1612, 580, 1612, 556, 540, 580, 1612, 580, 1612, 552, 1640, 580, 1612, 580, 1612, 580, 1612, 580, 516, 580, 1612, 556, 540, 556, 540, 556, 544, 576, 516, 572, 524, 556, 544, 552, 1636, 556, 544, 552, 544, 576, 520, 552, 544, 552, 544, 556, 540, 556, 540, 556, 540, 552, 1640, 552, 1640, 556, 1636, 552, 1640, 556, 1636, 556, 1636, 556, 1636, 556}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima27[] = {4472, 4432, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 544, 552, 1636, 556, 1640, 552, 544, 552, 1640, 552, 1640, 552, 544, 552, 1640, 552, 1640, 552, 1640, 556, 1636, 552, 1640, 552, 1640, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 540, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 544, 552, 544, 552, 540, 556, 544, 552, 540, 560, 1636, 552, 1640, 552, 544, 552, 1640, 556, 1636, 556, 1636, 552, 1640, 552, 5292, 4496, 4428, 556, 1640, 556, 540, 556, 1636, 552, 1640, 552, 544, 552, 544, 552, 1640, 556, 540, 556, 540, 552, 1640, 556, 540, 552, 544, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1640, 552, 1636, 556, 1640, 556, 1636, 552, 1640, 552, 544, 556, 1636, 552, 544, 552, 544, 556, 540, 556, 540, 572, 524, 552, 544, 556, 1636, 552, 544, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 540, 552, 544, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima26[] = {4468, 4432, 556, 1636, 556, 544, 552, 1636, 556, 1640, 552, 544, 552, 544, 556, 1636, 556, 540, 552, 544, 556, 1636, 552, 544, 552, 544, 552, 1640, 552, 1640, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1640, 552, 544, 552, 1636, 556, 544, 552, 544, 552, 544, 552, 544, 552, 544, 552, 544, 556, 1636, 552, 1640, 552, 544, 556, 1636, 552, 544, 552, 544, 556, 564, 532, 540, 552, 544, 556, 540, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 5288, 4496, 4432, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 556, 540, 540, 556, 1636, 556, 540, 556, 568, 528, 1636, 556, 544, 552, 540, 556, 1640, 552, 1640, 552, 540, 556, 1640, 552, 1636, 556, 544, 552, 1640, 552, 1640, 552, 1640, 556, 1636, 556, 1636, 552, 1640, 556, 540, 556, 1636, 552, 544, 556, 540, 556, 540, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 544, 552, 1636, 556, 544, 552, 540, 556, 544, 552, 540, 556, 544, 552, 544, 552, 1636, 556, 540, 556, 1636, 556, 1640, 552, 1640, 552, 1640, 552}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima25[] = {4476, 4428, 552, 1640, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 544, 576, 1616, 552, 1636, 556, 544, 576, 1616, 556, 1636, 552, 544, 556, 1636, 552, 1640, 556, 1636, 552, 1640, 556, 1636, 556, 1636, 556, 540, 556, 1636, 552, 544, 552, 544, 556, 540, 556, 540, 556, 568, 528, 540, 556, 1636, 556, 1636, 556, 540, 556, 540, 556, 540, 556, 540, 556, 544, 552, 540, 556, 540, 556, 544, 552, 1636, 556, 1640, 580, 1612, 552, 1636, 556, 1640, 552, 1644, 552, 5288, 4492, 4432, 556, 1640, 552, 544, 556, 1636, 552, 1640, 552, 544, 552, 544, 552, 1640, 556, 540, 552, 544, 556, 1636, 556, 540, 556, 540, 556, 1636, 552, 1640, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 544, 552, 1636, 556, 544, 552, 544, 552, 544, 552, 544, 552, 544, 552, 544, 552, 1640, 552, 1640, 556, 540, 552, 544, 556, 540, 552, 544, 556, 540, 556, 540, 556, 540, 552, 544, 552, 1640, 552, 1640, 556, 1636, 552, 1640, 556, 1636, 556, 1636, 556}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima24[] = {4468, 4432, 556, 1640, 556, 564, 528, 1664, 528, 1640, 552, 568, 532, 540, 556, 1636, 556, 540, 556, 568, 528, 1636, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 544, 552, 1636, 556, 1636, 556, 568, 528, 1664, 528, 1640, 552, 1636, 556, 1640, 556, 1636, 552, 1664, 532, 540, 552, 1640, 552, 568, 532, 564, 532, 540, 556, 544, 552, 564, 532, 540, 552, 572, 528, 1664, 528, 540, 556, 540, 556, 540, 556, 540, 556, 568, 528, 540, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1640, 552, 1664, 528, 1640, 552, 1640, 552, 5288, 4496, 4432, 556, 1640, 552, 540, 556, 1636, 556, 1664, 528, 544, 552, 544, 552, 1640, 552, 568, 528, 544, 556, 1636, 552, 544, 556, 540, 556, 1636, 556, 1636, 552, 568, 528, 1640, 556, 1636, 552, 572, 524, 1640, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 568, 528, 568, 528, 544, 552, 544, 552, 544, 552, 1636, 556, 568, 528, 544, 552, 568, 528, 568, 528, 568, 532, 564, 532, 1636, 552, 544, 552, 1664, 528, 1640, 556, 1660, 532, 1636, 556, 1636, 552, 1640, 556}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima23[] = {4492, 4428, 580, 1612, 580, 516, 556, 1636, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 584, 516, 552, 1636, 580, 516, 580, 516, 584, 1608, 580, 1612, 580, 520, 580, 1608, 584, 1612, 576, 520, 580, 1612, 576, 1616, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 516, 580, 516, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 516, 584, 1608, 580, 516, 580, 1616, 580, 516, 580, 1612, 580, 1612, 576, 1616, 576, 1616, 580, 5264, 4496, 4432, 580, 1612, 580, 516, 580, 1612, 580, 1612, 580, 516, 580, 516, 580, 1612, 576, 520, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 1612, 580, 516, 580, 1612, 580, 1612, 580, 520, 576, 1616, 576, 1616, 576, 1616, 580, 1612, 576, 1616, 576, 1616, 580, 516, 576, 1616, 580, 516, 580, 516, 576, 520, 576, 520, 580, 516, 580, 516, 580, 516, 580, 1612, 580, 516, 576, 1616, 580, 516, 580, 516, 580, 516, 580, 516, 580, 1616, 576, 520, 576, 1612, 580, 520, 576, 1616, 576, 1616, 576, 1616, 576, 1616, 552}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima22[] = {4468, 4436, 552, 1664, 532, 564, 528, 1664, 532, 1664, 528, 540, 556, 544, 552, 1664, 528, 568, 528, 568, 528, 1640, 552, 568, 528, 568, 528, 1664, 528, 1664, 528, 568, 528, 1664, 528, 1640, 552, 568, 528, 1664, 528, 1664, 532, 1636, 556, 1636, 556, 1660, 528, 1640, 556, 540, 552, 1640, 552, 568, 528, 568, 532, 568, 528, 544, 552, 568, 528, 568, 528, 568, 528, 1664, 528, 1636, 556, 1644, 548, 568, 528, 568, 528, 568, 528, 568, 528, 1664, 528, 568, 528, 568, 528, 568, 528, 1664, 528, 1664, 528, 1664, 532, 1660, 528, 5292, 4492, 4432, 556, 1664, 528, 568, 528, 1664, 528, 1640, 552, 568, 528, 568, 528, 1664, 528, 572, 528, 564, 528, 1664, 528, 572, 528, 568, 528, 1636, 556, 1636, 556, 540, 556, 1664, 528, 1664, 528, 568, 528, 1640, 552, 1636, 556, 1640, 552, 1664, 528, 1664, 528, 1664, 528, 568, 528, 1664, 528, 568, 528, 568, 528, 568, 532, 564, 528, 568, 528, 568, 528, 568, 528, 1640, 552, 1640, 552, 1664, 528, 568, 528, 572, 528, 568, 528, 568, 528, 1664, 528, 568, 528, 568, 528, 568, 528, 1664, 528, 1664, 528, 1640, 552, 1664, 528}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima21[] = {4484, 4436, 576, 1616, 552, 544, 552, 1640, 552, 1640, 552, 544, 552, 544, 552, 1640, 576, 520, 580, 516, 576, 1616, 556, 540, 580, 516, 556, 1636, 580, 1612, 580, 516, 576, 1616, 580, 1612, 580, 516, 580, 1612, 580, 1612, 580, 1616, 552, 1640, 576, 1616, 576, 1616, 576, 520, 576, 1616, 580, 516, 576, 520, 576, 520, 552, 544, 580, 516, 580, 516, 576, 520, 556, 1636, 580, 1612, 576, 520, 580, 516, 580, 516, 576, 520, 580, 516, 576, 1616, 580, 516, 580, 516, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 576, 1616, 580, 5268, 4492, 4432, 580, 1612, 580, 516, 556, 1640, 576, 1612, 556, 544, 576, 520, 576, 1616, 576, 520, 576, 520, 580, 1612, 552, 544, 576, 520, 580, 1612, 576, 1616, 576, 520, 552, 1640, 580, 1612, 580, 516, 580, 1612, 580, 1612, 576, 1616, 580, 1612, 580, 1612, 556, 1636, 580, 516, 580, 1612, 576, 524, 576, 520, 576, 520, 576, 520, 576, 520, 576, 516, 580, 520, 576, 1616, 552, 1640, 580, 516, 576, 520, 580, 516, 580, 516, 552, 544, 552, 1640, 576, 520, 580, 516, 576, 1616, 580, 1612, 580, 1612, 576, 1616, 580, 1612, 552}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_clima20[] = {4468, 4452, 560, 1632, 560, 536, 560, 1632, 560, 1632, 560, 536, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1632, 560, 1632, 560, 536, 560, 1632, 556, 540, 556, 540, 556, 540, 560, 536, 556, 540, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1632, 560, 1636, 556, 1632, 560, 5284, 4472, 4452, 560, 1632, 560, 540, 552, 1636, 560, 1632, 560, 536, 560, 536, 556, 1636, 556, 540, 556, 540, 560, 1632, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1632, 556, 1636, 560, 1632, 560, 536, 560, 1632, 556, 540, 556, 540, 560, 540, 556, 536, 556, 540, 556, 540, 556, 540, 556, 540, 560, 1632, 556, 540, 556, 540, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 1632, 560, 1632, 560, 1632, 560, 1632, 560}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi30[] = {4444, 4456, 560, 1636, 552, 544, 556, 1636, 556, 1636, 556, 540, 556, 540, 556, 1636, 560, 536, 556, 540, 560, 1632, 560, 540, 556, 540, 556, 1636, 556, 1636, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 540, 556, 1636, 560, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 560, 1636, 556, 540, 556, 540, 556, 540, 552, 544, 556, 540, 556, 1636, 556, 540, 556, 1636, 556, 1636, 556, 540, 560, 1636, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 1636, 560, 1632, 560, 5288, 4472, 4456, 556, 1636, 556, 540, 556, 1636, 560, 1632, 560, 536, 560, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 556, 1636, 560, 536, 560, 1636, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 1636, 560, 1632, 560, 1632, 560, 1636, 556, 1636, 556, 1636, 556, 540, 556, 540, 556, 540, 556, 540, 556, 540, 560, 1636, 556, 536, 560, 1636, 556, 1636, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1640, 556, 544, 552, 1636, 556, 1636, 556}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi29[] = {4472, 4428, 556, 1640, 552, 544, 576, 1616, 576, 1616, 576, 520, 576, 520, 552, 1640, 580, 516, 552, 544, 556, 1636, 576, 520, 576, 520, 580, 1612, 556, 1636, 556, 540, 556, 1636, 580, 516, 556, 540, 556, 540, 556, 1636, 580, 1612, 556, 1636, 556, 1636, 580, 1612, 580, 1612, 580, 1612, 560, 1632, 580, 520, 552, 544, 576, 520, 576, 520, 576, 520, 580, 1608, 580, 520, 576, 1616, 552, 544, 576, 520, 580, 1612, 580, 516, 576, 520, 576, 520, 576, 1616, 580, 520, 572, 1616, 556, 1636, 580, 516, 580, 1612, 556, 1636, 556, 5288, 4496, 4432, 580, 1612, 552, 544, 556, 1636, 580, 1612, 580, 516, 580, 516, 580, 1612, 552, 544, 580, 516, 580, 1612, 580, 516, 580, 516, 556, 1636, 580, 1612, 580, 520, 576, 1612, 580, 520, 576, 516, 580, 520, 576, 1612, 580, 1616, 556, 1636, 564, 1628, 576, 1616, 552, 1640, 576, 1616, 576, 1616, 576, 520, 576, 520, 576, 520, 580, 516, 564, 532, 556, 1636, 580, 516, 580, 1612, 556, 540, 576, 520, 556, 1636, 580, 516, 580, 516, 580, 516, 580, 1612, 580, 520, 576, 1612, 556, 1640, 576, 520, 552, 1636, 556, 1636, 580}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi28[] = {4472, 4464, 524, 1696, 496, 568, 528, 1664, 528, 1696, 496, 568, 528, 568, 528, 1640, 552, 568, 528, 544, 552, 1640, 552, 568, 532, 564, 528, 1640, 552, 1696, 496, 568, 528, 1696, 500, 596, 500, 564, 532, 540, 552, 1664, 532, 1660, 532, 1696, 496, 1664, 528, 1636, 556, 1664, 528, 1692, 500, 1664, 528, 540, 556, 568, 528, 568, 528, 600, 496, 568, 528, 1636, 556, 568, 528, 600, 496, 568, 528, 568, 528, 1664, 528, 544, 552, 568, 536, 560, 528, 1696, 496, 1664, 528, 1696, 496, 1640, 556, 564, 528, 1640, 556, 1692, 500, 5320, 4464, 4428, 556, 1664, 528, 600, 496, 1640, 556, 1636, 556, 564, 528, 600, 496, 1672, 524, 564, 532, 600, 496, 1636, 556, 580, 516, 568, 528, 1696, 496, 1664, 528, 568, 528, 1640, 552, 568, 528, 600, 496, 600, 496, 1696, 496, 1664, 528, 1664, 528, 1696, 496, 1664, 528, 1696, 496, 1640, 552, 1664, 528, 600, 496, 568, 532, 564, 528, 600, 496, 568, 528, 1696, 496, 568, 528, 568, 528, 600, 500, 596, 496, 1696, 496, 604, 496, 564, 532, 564, 528, 1640, 556, 1660, 532, 1636, 556, 1664, 528, 568, 528, 1696, 496, 1696, 496}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi27[] = {4468, 4432, 556, 1636, 552, 572, 528, 1636, 556, 1636, 556, 544, 552, 540, 556, 1636, 556, 540, 556, 540, 556, 1640, 552, 544, 552, 544, 552, 1640, 552, 1636, 556, 544, 552, 1640, 552, 544, 552, 544, 556, 564, 528, 1640, 552, 1640, 552, 1640, 556, 1660, 528, 1640, 556, 1636, 552, 1640, 556, 1636, 556, 540, 556, 540, 556, 568, 528, 540, 556, 540, 556, 1636, 552, 544, 556, 544, 552, 1636, 556, 540, 556, 1636, 556, 544, 552, 540, 556, 544, 552, 1636, 556, 1636, 556, 544, 552, 1640, 552, 544, 552, 1636, 556, 1640, 552, 5292, 4492, 4432, 556, 1636, 556, 544, 552, 1640, 552, 1640, 556, 564, 528, 544, 552, 1640, 552, 544, 552, 544, 556, 1636, 556, 564, 532, 540, 552, 1640, 556, 1636, 556, 568, 528, 1636, 556, 540, 556, 540, 556, 540, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 1640, 552, 1636, 556, 1640, 552, 544, 552, 544, 552, 544, 552, 544, 552, 544, 552, 1640, 552, 568, 528, 544, 552, 1640, 552, 544, 556, 1636, 556, 540, 552, 544, 556, 540, 552, 1640, 556, 1636, 552, 544, 556, 1636, 552, 544, 556, 1636, 556, 1636, 556}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi26[] = {4440, 4464, 548, 1644, 548, 572, 528, 1664, 524, 1668, 528, 568, 528, 568, 524, 1644, 552, 568, 528, 568, 528, 1664, 528, 568, 552, 544, 548, 1620, 552, 1664, 528, 568, 528, 1664, 528, 568, 528, 572, 524, 568, 528, 1664, 528, 1664, 524, 1672, 524, 1668, 524, 1644, 548, 1668, 528, 1660, 528, 1668, 524, 572, 524, 572, 524, 572, 524, 572, 524, 572, 524, 1668, 524, 1668, 524, 572, 524, 1668, 528, 568, 528, 1664, 528, 568, 528, 568, 528, 568, 528, 568, 528, 1664, 528, 568, 528, 1640, 552, 568, 528, 1644, 548, 1664, 528, 5296, 4464, 4460, 552, 1640, 552, 568, 528, 1664, 528, 1664, 528, 548, 548, 568, 528, 1668, 524, 568, 528, 568, 528, 1664, 528, 572, 524, 568, 528, 1668, 524, 1668, 524, 572, 524, 1668, 524, 572, 524, 572, 524, 572, 524, 1668, 524, 1668, 524, 1668, 524, 1668, 528, 1664, 528, 1664, 528, 1664, 528, 1664, 528, 568, 524, 572, 528, 568, 528, 568, 524, 572, 528, 1668, 524, 1664, 528, 568, 528, 1664, 528, 572, 524, 1644, 548, 568, 528, 568, 528, 572, 524, 572, 524, 1668, 524, 572, 524, 1668, 528, 568, 524, 1668, 524, 1668, 524}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi24[] = {4472, 4428, 580, 1616, 576, 516, 580, 1616, 580, 1612, 580, 516, 580, 516, 580, 1612, 576, 520, 580, 516, 580, 1612, 580, 516, 576, 520, 580, 1612, 580, 1612, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 516, 576, 1616, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 580, 1616, 576, 520, 576, 520, 580, 516, 576, 520, 576, 520, 576, 520, 576, 1616, 576, 520, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 1612, 580, 1612, 580, 1612, 572, 524, 556, 1636, 580, 1612, 580, 5264, 4496, 4432, 580, 1612, 580, 516, 580, 1612, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 1616, 576, 516, 584, 1608, 580, 520, 576, 520, 576, 520, 580, 1612, 576, 1616, 580, 1612, 580, 1612, 576, 1616, 580, 1612, 580, 1612, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 516, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 1612, 580, 516, 584, 512, 580, 1612, 580, 520, 576, 1612, 584, 1608, 584, 1612, 580, 512, 556, 1636, 580, 1612, 580}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi25[] = {4476, 4428, 576, 1616, 580, 516, 580, 1612, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 1612, 580, 520, 576, 1612, 580, 516, 580, 516, 580, 516, 584, 1608, 560, 1636, 576, 1612, 580, 1616, 576, 1616, 576, 1616, 580, 1612, 576, 1616, 580, 516, 580, 516, 580, 516, 580, 516, 580, 516, 576, 1616, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 516, 580, 1616, 576, 1612, 580, 1612, 580, 520, 576, 1612, 580, 1612, 580, 5264, 4500, 4428, 580, 1612, 580, 516, 580, 1612, 580, 1612, 580, 516, 580, 520, 576, 1616, 576, 520, 576, 520, 576, 1616, 580, 516, 576, 520, 580, 1612, 576, 1616, 576, 520, 580, 1612, 576, 520, 580, 516, 580, 516, 580, 1612, 576, 1616, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 580, 1612, 584, 1608, 556, 540, 580, 516, 580, 516, 580, 516, 580, 516, 580, 1612, 584, 1608, 584, 516, 580, 516, 576, 516, 580, 1616, 580, 516, 580, 516, 580, 516, 580, 516, 576, 1616, 580, 1612, 580, 1612, 580, 516, 576, 1616, 580, 1612, 580}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi23[] = {4472, 4432, 552, 1640, 552, 544, 552, 1640, 580, 1612, 556, 540, 580, 516, 552, 1640, 556, 540, 552, 544, 576, 1616, 556, 540, 580, 516, 556, 1636, 556, 1636, 556, 544, 552, 1636, 580, 516, 580, 516, 580, 520, 552, 1640, 576, 1616, 576, 1616, 552, 1640, 552, 1640, 552, 1640, 552, 1640, 552, 1640, 556, 540, 552, 544, 580, 516, 556, 540, 556, 540, 576, 520, 580, 1612, 576, 520, 580, 1612, 556, 540, 556, 1636, 556, 540, 580, 516, 556, 1636, 556, 544, 576, 1612, 556, 540, 556, 1636, 556, 540, 560, 1632, 580, 1616, 552, 5292, 4496, 4428, 580, 1612, 556, 544, 572, 1620, 576, 1612, 580, 520, 552, 540, 556, 1640, 576, 520, 576, 520, 576, 1616, 576, 520, 576, 520, 576, 1616, 576, 1616, 560, 536, 552, 1640, 556, 540, 572, 524, 556, 540, 552, 1640, 556, 1636, 552, 1640, 556, 1636, 556, 1636, 556, 1636, 560, 1632, 580, 1612, 556, 540, 556, 540, 556, 540, 556, 540, 560, 540, 576, 516, 556, 1636, 556, 544, 552, 1640, 560, 560, 528, 1640, 556, 540, 552, 544, 576, 1616, 580, 516, 552, 1640, 552, 544, 556, 1636, 580, 516, 556, 1636, 572, 1620, 576}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi22[] = {4496, 4428, 580, 1608, 584, 516, 580, 1612, 580, 1608, 588, 512, 580, 516, 580, 1612, 584, 512, 584, 512, 584, 1608, 580, 516, 584, 512, 584, 1608, 584, 1608, 584, 512, 584, 1608, 584, 512, 584, 512, 584, 512, 584, 1608, 584, 1608, 584, 1608, 584, 1608, 584, 1608, 584, 1608, 584, 1612, 580, 1608, 584, 516, 580, 512, 584, 516, 584, 512, 584, 512, 580, 516, 584, 1608, 584, 1608, 580, 1612, 580, 516, 584, 1608, 584, 512, 584, 512, 584, 1608, 584, 512, 584, 512, 580, 516, 584, 1608, 584, 512, 584, 1608, 584, 1608, 584, 5260, 4500, 4428, 584, 1608, 584, 512, 584, 1608, 584, 1608, 584, 512, 584, 512, 584, 1608, 584, 512, 584, 512, 584, 1612, 580, 512, 584, 516, 580, 1608, 584, 1608, 584, 516, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 1612, 584, 1608, 584, 1608, 580, 1612, 584, 1608, 584, 1608, 584, 1608, 584, 1608, 584, 512, 580, 516, 580, 516, 584, 512, 584, 512, 584, 512, 584, 1608, 584, 1608, 584, 1608, 584, 512, 584, 1608, 584, 516, 580, 516, 580, 1608, 584, 516, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 1612, 580, 1612, 584}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi21[] = {4492, 4432, 580, 1612, 580, 516, 580, 1612, 580, 1612, 584, 512, 584, 512, 584, 1608, 580, 516, 584, 512, 584, 1608, 584, 512, 584, 512, 584, 1608, 584, 1608, 584, 512, 580, 1612, 584, 512, 584, 512, 584, 512, 584, 1608, 584, 1608, 584, 1608, 584, 1612, 580, 1612, 580, 1612, 584, 1608, 580, 1612, 580, 516, 580, 516, 580, 516, 580, 516, 584, 512, 584, 512, 584, 1608, 584, 1608, 584, 512, 580, 516, 584, 1608, 584, 512, 584, 512, 584, 1608, 584, 512, 584, 512, 584, 1608, 584, 1608, 584, 512, 584, 1608, 584, 1608, 584, 5264, 4496, 4428, 584, 1608, 584, 512, 584, 1608, 584, 1608, 584, 512, 584, 512, 584, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 580, 516, 580, 1612, 580, 1612, 584, 512, 580, 1612, 584, 512, 584, 512, 584, 512, 580, 1612, 584, 1608, 584, 1608, 584, 1608, 584, 1608, 584, 1608, 584, 1608, 584, 1608, 584, 512, 584, 512, 584, 512, 584, 512, 584, 512, 584, 516, 580, 1608, 584, 1612, 580, 516, 580, 516, 580, 1612, 580, 516, 584, 512, 584, 1608, 580, 516, 580, 516, 580, 1612, 580, 1612, 580, 516, 584, 1608, 584, 1608, 584}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_ON_deumi20[] = {4472, 4452, 560, 1632, 560, 536, 560, 1636, 556, 1636, 580, 516, 556, 540, 580, 1612, 556, 540, 556, 540, 580, 1612, 556, 540, 580, 516, 556, 1636, 560, 1632, 584, 516, 580, 1612, 556, 540, 580, 516, 556, 540, 556, 1636, 556, 1636, 580, 1612, 556, 1636, 560, 1636, 556, 1636, 556, 1636, 556, 1636, 556, 540, 556, 540, 580, 516, 556, 540, 556, 540, 580, 516, 580, 516, 556, 1636, 560, 536, 560, 540, 556, 1636, 580, 516, 580, 516, 556, 1636, 556, 1636, 580, 516, 584, 1608, 580, 1612, 560, 536, 560, 1636, 556, 1636, 580, 5264, 4500, 4428, 556, 1636, 560, 536, 560, 1632, 560, 1636, 556, 540, 580, 516, 556, 1636, 580, 516, 556, 540, 556, 1636, 556, 540, 556, 540, 556, 1636, 584, 1608, 580, 520, 576, 1616, 580, 516, 556, 540, 556, 540, 556, 1636, 580, 1612, 560, 1632, 560, 1632, 556, 1636, 560, 1636, 556, 1636, 556, 1636, 556, 540, 580, 516, 564, 532, 556, 540, 560, 536, 580, 516, 560, 536, 560, 1632, 560, 540, 576, 520, 556, 1636, 556, 544, 552, 540, 556, 1636, 556, 1636, 560, 536, 580, 1612, 556, 1636, 560, 536, 560, 1636, 552, 1640, 560}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_30_Calore[] = {4508, 4408, 612, 1612, 588, 512, 584, 1612, 584, 1588, 608, 512, 592, 504, 588, 1612, 588, 512, 584, 512, 584, 1588, 612, 508, 588, 512, 588, 1608, 588, 1608, 588, 512, 588, 1612, 584, 1608, 588, 512, 588, 1608, 588, 1608, 588, 1612, 584, 1608, 588, 1608, 588, 1612, 588, 508, 588, 1612, 584, 512, 588, 512, 584, 512, 588, 512, 588, 508, 588, 512, 588, 1608, 588, 512, 584, 1608, 592, 1608, 588, 1608, 588, 1608, 592, 508, 588, 508, 592, 508, 592, 1604, 584, 516, 584, 512, 588, 512, 584, 516, 584, 1584, 612, 1608, 588, 5244, 4536, 4408, 612, 1612, 584, 516, 588, 1604, 588, 1612, 584, 512, 588, 508, 592, 1608, 584, 516, 584, 512, 584, 1612, 588, 508, 592, 508, 588, 1608, 588, 1588, 608, 512, 588, 1608, 588, 1612, 584, 512, 588, 1608, 588, 1608, 588, 1608, 588, 1612, 584, 1608, 592, 1604, 588, 516, 584, 1612, 584, 512, 588, 512, 588, 508, 588, 512, 584, 512, 588, 512, 588, 1608, 584, 516, 584, 1612, 588, 1608, 588, 1608, 584, 1588, 612, 512, 588, 508, 592, 508, 588, 1608, 584, 512, 592, 508, 588, 512, 584, 512, 588, 1608, 588, 1588, 608}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_29_Calore[] = {4512, 4408, 612, 1608, 588, 488, 608, 1608, 592, 1584, 612, 508, 592, 508, 588, 1588, 608, 512, 588, 508, 588, 1588, 608, 512, 588, 512, 584, 1608, 592, 1608, 588, 508, 588, 1588, 612, 1604, 592, 508, 592, 1604, 592, 1604, 592, 1604, 592, 1604, 592, 1608, 592, 1604, 588, 512, 588, 1584, 612, 508, 592, 508, 588, 508, 588, 512, 588, 512, 584, 492, 612, 1604, 592, 508, 588, 1604, 592, 512, 588, 1588, 608, 1604, 592, 508, 592, 508, 588, 512, 588, 1584, 612, 508, 592, 1584, 608, 512, 592, 504, 592, 1584, 612, 1608, 588, 5244, 4536, 4408, 612, 1608, 588, 512, 584, 1592, 608, 1608, 588, 488, 608, 512, 588, 1608, 588, 512, 588, 508, 592, 1604, 592, 488, 608, 512, 588, 1608, 588, 1608, 588, 508, 588, 1608, 592, 1584, 612, 508, 592, 1604, 588, 1608, 592, 1604, 588, 1588, 612, 1584, 616, 1580, 612, 512, 588, 1608, 588, 508, 592, 508, 592, 504, 588, 512, 588, 512, 584, 512, 588, 1608, 592, 508, 588, 1584, 612, 512, 588, 1604, 592, 1604, 592, 512, 584, 512, 588, 508, 588, 1588, 608, 512, 592, 1604, 592, 508, 588, 508, 592, 1584, 612, 1608, 588}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_28_Calore[] = {4508, 4408, 612, 1608, 588, 512, 588, 1584, 616, 1604, 592, 508, 588, 508, 592, 1608, 584, 516, 588, 504, 588, 1612, 588, 508, 592, 508, 588, 1608, 588, 1584, 612, 512, 588, 1584, 612, 1608, 588, 508, 592, 1608, 588, 1608, 588, 1604, 592, 1608, 592, 1604, 588, 1608, 588, 512, 588, 1608, 588, 488, 612, 508, 588, 512, 588, 508, 588, 512, 588, 512, 588, 1608, 584, 512, 588, 512, 588, 508, 588, 1608, 592, 1608, 584, 512, 588, 512, 588, 508, 588, 1608, 588, 1612, 584, 1608, 592, 508, 588, 488, 612, 1608, 584, 1612, 588, 5240, 4540, 4408, 612, 1612, 584, 512, 588, 1608, 588, 1608, 592, 508, 584, 512, 588, 1608, 588, 512, 592, 504, 592, 1608, 584, 512, 592, 508, 588, 1584, 612, 1584, 612, 508, 588, 1608, 592, 1608, 588, 508, 588, 1608, 592, 1584, 612, 1608, 588, 1608, 588, 1608, 588, 1608, 588, 512, 588, 1608, 588, 508, 588, 512, 592, 508, 588, 508, 588, 512, 588, 508, 588, 1588, 612, 508, 588, 512, 588, 508, 588, 1608, 588, 1608, 592, 508, 588, 512, 588, 508, 588, 1608, 588, 1608, 592, 1604, 592, 512, 584, 512, 588, 1608, 588, 1608, 588}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_27_Calore[] = {4544, 4372, 648, 1556, 640, 456, 644, 1556, 636, 1560, 640, 460, 640, 456, 640, 1556, 640, 456, 644, 456, 644, 1552, 640, 460, 640, 456, 644, 1552, 640, 1560, 636, 460, 644, 1552, 644, 1552, 644, 452, 644, 1556, 640, 1560, 636, 1556, 644, 1552, 644, 1556, 640, 1556, 640, 452, 648, 1552, 640, 460, 644, 452, 640, 460, 640, 464, 636, 456, 644, 456, 640, 1556, 644, 456, 640, 460, 640, 1552, 644, 1552, 640, 1556, 644, 456, 640, 460, 636, 460, 640, 1552, 648, 1556, 636, 460, 644, 456, 640, 456, 644, 1556, 636, 1556, 640, 5216, 4568, 4376, 644, 1556, 612, 484, 640, 1560, 640, 1556, 640, 456, 640, 460, 636, 1560, 636, 460, 640, 464, 636, 1556, 644, 456, 644, 456, 636, 1556, 640, 1556, 644, 460, 636, 1556, 640, 1556, 640, 460, 640, 1556, 640, 1556, 640, 1556, 640, 1556, 640, 1556, 644, 1556, 640, 456, 640, 1556, 636, 468, 632, 488, 616, 460, 608, 488, 636, 484, 616, 484, 616, 1556, 640, 460, 640, 460, 632, 1560, 612, 1588, 636, 1560, 636, 460, 640, 484, 616, 480, 620, 1552, 640, 1556, 644, 460, 636, 460, 636, 484, 612, 1564, 636, 1560, 608}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_26_Calore[] = {4508, 4404, 616, 1608, 592, 508, 592, 1608, 584, 1608, 588, 516, 584, 512, 588, 1584, 612, 508, 588, 516, 584, 1608, 592, 504, 592, 508, 588, 1608, 588, 1612, 588, 512, 584, 1608, 588, 1608, 588, 512, 588, 1608, 588, 1608, 588, 1608, 588, 1612, 588, 1604, 588, 1612, 584, 512, 588, 1608, 592, 508, 588, 512, 588, 508, 588, 512, 588, 508, 592, 508, 588, 1608, 588, 1584, 612, 512, 588, 1608, 584, 1608, 592, 1608, 588, 512, 584, 516, 588, 508, 588, 512, 588, 1584, 612, 508, 588, 512, 588, 508, 592, 1604, 588, 1608, 588, 5240, 4540, 4412, 616, 1600, 592, 508, 588, 1612, 588, 1584, 612, 508, 588, 512, 584, 1608, 592, 508, 588, 512, 584, 1612, 588, 512, 588, 508, 592, 1608, 584, 1608, 588, 512, 588, 1608, 588, 1608, 588, 512, 588, 1608, 588, 1608, 588, 1608, 592, 1604, 588, 1612, 584, 1612, 588, 508, 588, 1584, 616, 508, 584, 516, 584, 512, 588, 512, 588, 512, 584, 508, 592, 1608, 588, 1608, 588, 512, 584, 1588, 608, 1608, 592, 1608, 588, 512, 584, 512, 588, 512, 584, 516, 584, 1588, 612, 508, 588, 512, 588, 508, 588, 1608, 588, 1608, 588}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_25_Calore[] = {4508, 4408, 612, 1608, 592, 508, 588, 1604, 592, 1608, 588, 512, 588, 508, 584, 1612, 588, 508, 592, 508, 588, 1608, 588, 512, 588, 512, 588, 1604, 592, 1604, 592, 508, 588, 1588, 612, 1608, 588, 512, 588, 1584, 608, 1612, 584, 1608, 592, 1608, 588, 1608, 588, 1608, 588, 508, 592, 1608, 588, 512, 584, 512, 588, 508, 588, 512, 588, 512, 584, 516, 588, 1604, 588, 1608, 588, 512, 588, 508, 588, 1612, 588, 1608, 588, 508, 588, 512, 588, 512, 584, 512, 588, 1612, 584, 1608, 588, 512, 588, 508, 588, 1612, 584, 1612, 588, 5244, 4536, 4408, 612, 1608, 592, 508, 588, 1604, 592, 1608, 588, 512, 584, 512, 588, 1608, 588, 508, 588, 512, 592, 1604, 592, 508, 588, 512, 588, 1604, 588, 1608, 592, 508, 588, 1608, 592, 1608, 588, 508, 588, 1608, 588, 1608, 588, 1612, 584, 1608, 588, 1608, 592, 1608, 588, 508, 588, 1588, 612, 508, 588, 512, 588, 508, 588, 512, 588, 508, 588, 492, 608, 1608, 588, 1584, 612, 488, 612, 508, 592, 1584, 608, 1612, 584, 512, 588, 512, 588, 508, 592, 508, 588, 1608, 588, 1608, 588, 512, 588, 508, 592, 1604, 588, 1612, 584}; //AnalysIR Batch Export (IRremote) - RAW
uint16_t Signal_24_Calore[] = {4516, 4408, 612, 1584, 612, 488, 612, 1584, 612, 1608, 588, 508, 592, 508, 588, 1584, 612, 492, 608, 508, 588, 1608, 588, 512, 588, 488, 612, 1608, 588, 1608, 588, 512, 588, 1584, 612, 1584, 612, 488, 612, 1604, 588, 1608, 592, 1608, 588, 1608, 588, 1588, 608, 1608, 588, 492, 608, 1608, 588, 492, 608, 508, 588, 512, 588, 508, 588, 512, 588, 508, 588, 512, 588, 1584, 612, 508, 588, 512, 588, 1588, 608, 1588, 612, 508, 588, 488, 636, 1560, 608, 512, 588, 1608, 620, 1556, 640, 460, 636, 460, 640, 1560, 632, 1564, 608, 5240, 4568, 4380, 640, 1556, 612, 492, 636, 1556, 640, 1560, 640, 456, 644, 456, 640, 1556, 612, 484, 640, 484, 616, 1556, 640, 460, 612, 484, 640, 1556, 640, 1556, 644, 456, 640, 1556, 640, 1556, 612, 512, 616, 1556, 640, 1556, 636, 1564, 636, 1556, 640, 1560, 636, 1560, 640, 460, 636, 1556, 640, 460, 640, 460, 636, 460, 640, 484, 616, 460, 636, 460, 640, 460, 636, 1556, 640, 460, 640, 460, 640, 1552, 640, 1560, 640, 456, 640, 464, 636, 1556, 636, 464, 636, 1560, 640, 1556, 640, 460, 636, 460, 640, 1556, 640, 1556, 640}; //AnalysIR Batch Export (IRremote) - RAW



//********************************************************************************************** SETUP
void setup() {
  Serial.begin(115200);
  irsend.begin();

  Debug.begin(HOST_NAME);
  Debug.setSerialEnabled(true);
  Debug.setResetCmdEnabled(true); // Enable the reset command
  //Debug.showTime(true); // To show time
  // Debug.showProfiler(true); // To show profiler - time between messages of Debug
  // Good to "begin ...." and "end ...." messages
  ConnectWifi();
  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
    delay (5000);
    ConnectWifi();
  }
  OTA();
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
}
//********************************************************************************************** LOOP
void loop() {
  if (WiFi.waitForConnectResult() != WL_CONNECTED)
    ConnectWifi();
  if (!client.connected())
    reconnect();
  ArduinoOTA.handle();
  Debug.handle();

  if ((millis() - mLastTime) >= 1000) {
    mLastTime = millis();
    mTimeSeconds++;
    if (mTimeSeconds % 5 == 0)
      gettemperature();
    if (mTimeSeconds % 2 == 0)
      sendirdata();
  }
  client.loop();
  yield();
}
//********************************************************************************************** CONNECT WIFI
bool ConnectWifi() {
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);
  WiFi.begin(ssid, password);
}
//********************************************************************************************** CALLBACK
void callback(char* topic, byte* payload, unsigned int length) {
  payload[length] = '\0'; // Null terminator used to terminate the char array
  String message = (char*)payload;
  if ((strcmp (topic, inTopic_targetHumidity) == 0) || (strcmp (topic, inTopic_RecHumidity) == 0)) {         //  HOME/Termostato/Target/Humidity";
    char receivedAll1[length];
    for (int x = 0; x < length; x++) {
      char receivedChar1 = (char)payload[x];
      receivedAll1[x] = receivedChar1;
    }
    tarHum = atoi (receivedAll1);
    setCurrentHCS();
  }
  else if ((strcmp (topic, inTopic_targetTemperature) == 0) || (strcmp (topic, inTopic_RecTemperature) == 0)) {      //"HOME/Termostato/Target/Temperature";
    char receivedAll2[length];
    for (int y = 0; y < length; y++) {
      char receivedChar2 = (char)payload[y];
      receivedAll2[y] = receivedChar2;
    }
    tarTem = atoi (receivedAll2);
    setCurrentHCS();
  }
  else if (strcmp (topic, outTopic_targetHCS) == 0)  {              //"HOME/Termostato/Target/Hcs";
    char receivedAll3[length];
    for (int z = 0; z < length; z++) {
      char receivedChar3 = (char)payload[z];
      receivedAll3[z] = receivedChar3;
    }
    targetHCS = atoi (receivedAll3);        Debug.print("received targetHCS   "); Debug.println(targetHCS);
    setCurrentHCS();
  }
  else if (strcmp (topic, inTopic_GETtemperature) == 0) {   //topic "HOME/Thermostat/getStatus/Temperature"
    if (message == questMsg) {
      dtostrf(temp , 2, 2, msg);
      client.publish(outTopic_CurrentTemperature, msg);       //publish HOME/Thermostat/Current/Temperature
    }
    setCurrentHCS();
  }
  else if (strcmp (topic, inTopic_GEThumidity) == 0) {      //topic "HOME/Thermostat/getStatus/Humidity"
    if (message == questMsg) {
      dtostrf(humi , 2, 2, msg);
      client.publish(outTopic_CurrentHumidity, msg);          //publish HOME/Thermostat/Current/Humidity
    }
    setCurrentHCS();
  }
  Debug.println(" ");
}
//********************************************************************************************** SEND IR DATA
void sendirdata() {
  Debug.print("irstate :"); Debug.println(irstate);
  Debug.print("targetHCS  :"); Debug.println(targetHCS);
  Debug.print("currHCS :"); Debug.println(currHCS);
  Debug.print("tarTem  :"); Debug.println(tarTem);
  Debug.print("tarHum  :"); Debug.println(tarHum);
  Debug.print("temp :"); Debug.println(temp);
  Debug.print("humi :"); Debug.println(humi);
  if (currHCS == 2) {
    if ((prevTtemp != tarTem) || (prevThum != tarHum)) {
      if (humi > tarHum) {
        Debug.println("*****Deumidificatore");
        if (tarTem == 20)
          irsend.sendRaw(Signal_ON_clima20, sizeof(Signal_ON_clima20) / sizeof(Signal_ON_clima20[0]), khz);
        else if (tarTem == 21)
          irsend.sendRaw(Signal_ON_clima21, sizeof(Signal_ON_clima21) / sizeof(Signal_ON_clima21[0]), khz);
        else if (tarTem == 22)
          irsend.sendRaw(Signal_ON_clima22, sizeof(Signal_ON_clima22) / sizeof(Signal_ON_clima22[0]), khz);
        else if (tarTem == 23)
          irsend.sendRaw(Signal_ON_clima23, sizeof(Signal_ON_clima23) / sizeof(Signal_ON_clima23[0]), khz);
        else if (tarTem == 24)
          irsend.sendRaw(Signal_ON_clima24, sizeof(Signal_ON_clima24) / sizeof(Signal_ON_clima24[0]), khz);
        else if (tarTem == 25)
          irsend.sendRaw(Signal_ON_clima25, sizeof(Signal_ON_clima25) / sizeof(Signal_ON_clima25[0]), khz);
        else if (tarTem == 26)
          irsend.sendRaw(Signal_ON_clima26, sizeof(Signal_ON_clima26) / sizeof(Signal_ON_clima26[0]), khz);
        else if (tarTem == 27)
          irsend.sendRaw(Signal_ON_clima27, sizeof(Signal_ON_clima27) / sizeof(Signal_ON_clima27[0]),  khz);
        else if (tarTem == 28)
          irsend.sendRaw(Signal_ON_clima28, sizeof(Signal_ON_clima28) / sizeof(Signal_ON_clima28[0]),  khz);
        else if (tarTem == 29)
          irsend.sendRaw(Signal_ON_clima29, sizeof(Signal_ON_clima29) / sizeof(Signal_ON_clima29[0]),  khz);
        else if (tarTem == 30)
          irsend.sendRaw(Signal_ON_clima30, sizeof(Signal_ON_clima30) / sizeof(Signal_ON_clima30[0]),  khz);
        irstate = true;
      } else if (humi <= tarHum) {
        Debug.println("*****Condizionatore");
        if (tarTem == 20)
          irsend.sendRaw(Signal_ON_deumi20, sizeof(Signal_ON_deumi20) / sizeof(Signal_ON_deumi20[0]),  khz);
        else if (tarTem == 21)
          irsend.sendRaw(Signal_ON_deumi21, sizeof(Signal_ON_deumi21) / sizeof(Signal_ON_deumi21[0]),  khz);
        else if (tarTem == 22)
          irsend.sendRaw(Signal_ON_deumi22, sizeof(Signal_ON_deumi22) / sizeof(Signal_ON_deumi22[0]),  khz);
        else if (tarTem == 23)
          irsend.sendRaw(Signal_ON_deumi23, sizeof(Signal_ON_deumi23) / sizeof(Signal_ON_deumi23[0]),  khz);
        else if (tarTem == 24)
          irsend.sendRaw(Signal_ON_deumi24, sizeof(Signal_ON_deumi24) / sizeof(Signal_ON_deumi24[0]),  khz);
        else if (tarTem == 25)
          irsend.sendRaw(Signal_ON_deumi25, sizeof(Signal_ON_deumi25) / sizeof(Signal_ON_deumi25[0]),  khz);
        else if (tarTem == 26)
          irsend.sendRaw(Signal_ON_deumi26, sizeof(Signal_ON_deumi26) / sizeof(Signal_ON_deumi26[0]), khz);
        else  if (tarTem == 27)
          irsend.sendRaw(Signal_ON_deumi27, sizeof(Signal_ON_deumi27) / sizeof(Signal_ON_deumi27[0]),  khz);
        else if (tarTem == 28)
          irsend.sendRaw(Signal_ON_deumi28, sizeof(Signal_ON_deumi28) / sizeof(Signal_ON_deumi28[0]), khz);
        else if (tarTem == 29)
          irsend.sendRaw(Signal_ON_deumi29, sizeof(Signal_ON_deumi29) / sizeof(Signal_ON_deumi29[0]),  khz);
        else if (tarTem == 30)
          irsend.sendRaw(Signal_ON_deumi30, sizeof(Signal_ON_deumi30) / sizeof(Signal_ON_deumi30[0]),  khz);
        irstate = true;
      }
      prevTtemp = tarTem;
      prevThum = tarHum;
    }
  }
  /*
     nel caso in cui si voglia utilizzare il climatizzatore per gestire l'aria calda togliere il commento a questa porzione di testo e commentare la sezione subito sotto
    else if (currHCS == 1) {
    if ((prevTtemp != tarTem) || (prevThum != tarHum)) {
      if (tarTem == 24)
        irsend.sendRaw(Signal_24_Calore, sizeof(Signal_24_Calore) / sizeof(Signal_24_Calore[0]), khz);
      else if (tarTem == 25)
        irsend.sendRaw(Signal_25_Calore, sizeof(Signal_25_Calore) / sizeof(Signal_25_Calore[0]), khz);
      else if (tarTem == 26)
        irsend.sendRaw(Signal_26_Calore, sizeof(Signal_26_Calore) / sizeof(Signal_26_Calore[0]), khz);
      else if (tarTem == 27)
        irsend.sendRaw(Signal_27_Calore, sizeof(Signal_27_Calore) / sizeof(Signal_27_Calore[0]), khz);
      else if (tarTem == 28)
        irsend.sendRaw(Signal_28_Calore, sizeof(Signal_28_Calore) / sizeof(Signal_28_Calore[0]), khz);
      else if (tarTem == 29)
        irsend.sendRaw(Signal_29_Calore, sizeof(Signal_29_Calore) / sizeof(Signal_29_Calore[0]), khz);
      else if (tarTem == 30)
        irsend.sendRaw(Signal_30_Calore, sizeof(Signal_30_Calore) / sizeof(Signal_30_Calore[0]), khz);
      irstate = true;
      prevTtemp = tarTem;
      prevThum = tarHum;
    }
    }
    else if (currHCS == 0) {
    if (irstate == true) {
      irsend.sendRaw(Signal_OFF_0, sizeof(Signal_OFF_0) / sizeof(Signal_OFF_0[0]),  khz);
      irstate = false;
      prevTtemp = 0;
    }
    }

  */
  else if (currHCS != 2) {
    if (irstate == true) {
      irsend.sendRaw(Signal_OFF_0, sizeof(Signal_OFF_0) / sizeof(Signal_OFF_0[0]),  khz);
      irstate = false;
      prevTtemp = 0;
    }
  }

}
//********************************************************************************************** RECONNET
void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Debug.println("Attempting MQTT connection...");
    // Attempt to connect
    if (client.connect(HOST_NAME)) {
      Debug.println("connected");
      client.subscribe("HOME/Termostato/#");
      client.subscribe("irRemote");
      client.publish("HOME/Termostato/getall", "info");
      client.publish("HOME/Termostato/getStatus/Humidity", questMsg);
      client.publish("HOME/Termostato/getStatus/Temperature", questMsg);
    } else {
      Debug.print("failed, rc=");
      Debug.print(client.state());
      Debug.println(" try again in 5 second");
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}
//********************************************************************************************** GET TEMPERATURE
void gettemperature() {

  if (dht12.get() == 0) {
    currHumidity = dht12.humidity;
    currTemperature = dht12.cTemp;
  }

  //  int chk = DHT.read22(DHTPIN);
  //  currHumidity = DHT.humidity;
  //  currTemperature = DHT.temperature;
  // Check if any reads failed and exit early (to try again).
  if (isnan(currHumidity) || isnan(currTemperature)) {
    return;
  } else {
    temp = currTemperature;
    humi = currHumidity;
  }
}
//********************************************************************************************** SET CurrentHCS
void setCurrentHCS() {
  if (targetHCS == 0)
    currHCS = 0;
  else if (targetHCS == 1) {
    if ( tarTem > temp)
      currHCS = 1;
    else if (tarTem <= temp)
      currHCS = 0;
  }  else if (targetHCS == 2) {
    if (tarTem < temp)
      currHCS = 2;
    else if (tarTem >= temp)
      currHCS = 0;
  }  else if  (targetHCS == 3) {
    if ( tarTem > temp)
      currHCS = 1;
    else if  (tarTem == temp)
      currHCS = 0;
    else if  (tarTem < temp)
      currHCS = 2;
  }
}
//********************************************************************************************** GET TEMPERATURE
void OTA() {
  ArduinoOTA.setPort(8266);
  ArduinoOTA.setHostname(HOST_NAME);
  //ArduinoOTA.setPassword((const char *)"123");
  ArduinoOTA.onStart([]() {
    Debug.println("Start");
  });
  ArduinoOTA.onEnd([]() {
    Debug.println("\nEnd");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Debug.printf("Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Debug.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) Debug.println("Auth Failed");
    else if (error == OTA_BEGIN_ERROR) Debug.println("Begin Failed");
    else if (error == OTA_CONNECT_ERROR) Debug.println("Connect Failed");
    else if (error == OTA_RECEIVE_ERROR) Debug.println("Receive Failed");
    else if (error == OTA_END_ERROR) Debug.println("End Failed");
  });
  ArduinoOTA.begin();
}
